unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  IniFiles, ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_CKProductBCPKCHZList, U_CKProductBCPKCList,
  U_CKProductBCPOutList, U_CKProductBCPInList, U_FCSMCK, U_CPHXCK,
  U_CKProductBCPOutListHZ, U_CPSMRk, U_CPDBAO, U_CKProductBCPinListHZ, U_CPCKHZ,
  U_CKProductBCcbPKCHZList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmCKProductBCPInListGL, frmCKProductBCPInListCX: TfrmCKProductBCPInList;
  frmCKProductBCPOutListGL, frmCKProductBCPOutListCX: TfrmCKProductBCPOutList;
  frmCKProductBCCBPKCHZList, frmCKProductBCCBPKCHZListCX: tfrmCKProductBCCBPKCHZList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '47.100.130.130,7781';
//  server := '.';
  dtbase := 'ZHENYONGDATA';
  user := 'zhenyongsa';
  pswd := 'rightsoft@9101';
  // pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DConString := DataBaseStr;
//   DName:='王俊杰';
//   DParameters1:='高权限';

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    105: // 布匹打包
      begin
        if frmCPDBao = nil then
        begin
          frmCPDBao := TfrmCPDBao.Create(application.MainForm);
          with frmCPDBao do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPDBao.BringToFront;
       //句柄
        mnewHandle := frmCPDBao.Handle;
      end;

    101:  //扫描入库
      begin
        if frmCPSMRk = nil then
        begin
          frmCPSMRk := TfrmCPSMRk.Create(application.MainForm);
          with frmCPSMRk do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
          end;
        end
        else
          frmCPSMRk.BringToFront;
       //句柄
        mnewHandle := frmCPSMRk.Handle;
      end;
    111:  //成品入库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品入库管理' then
          begin
            BringWindowToTop(frmCKProductBCPInListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPInListGL := TfrmCKProductBCPInList.Create(application.MainForm);
          with frmCKProductBCPInListGL do
          begin
            canshu1 := '管理';
            Title := '成品入库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPInListGL.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPInListGL.Handle;
      end;

    112:  //成品入库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品入库查询' then
          begin
            BringWindowToTop(frmCKProductBCPInListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPInListCX := TfrmCKProductBCPInList.Create(application.MainForm);
          with frmCKProductBCPInListCX do
          begin
            canshu1 := '查询';
            Title := '成品入库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPInListCX.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPInListCX.Handle;
      end;

    113:  //成品入库汇总
      begin
        if frmCKProductBCPinListHZ = nil then
        begin
          frmCKProductBCPinListHZ := TfrmCKProductBCPinListHZ.Create(application.MainForm);
          with frmCKProductBCPinListHZ do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPinListHZ.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPinListHZ.Handle;
      end;
    221:  //扫描出库
      begin
        if frmFCSMCK = nil then
        begin
          frmFCSMCK := TfrmFCSMCK.Create(application.MainForm);
          with frmFCSMCK do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFCSMCK.BringToFront;
       //句柄
        mnewHandle := frmFCSMCK.Handle;
      end;
    222:  //回修扫描出库
      begin
        if frmCPHXCK = nil then
        begin
          frmCPHXCK := TfrmCPHXCK.Create(application.MainForm);
          with frmCPHXCK do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPHXCK.BringToFront;
       //句柄
        mnewHandle := frmCPHXCK.Handle;
      end;
    211:  //成品出库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品出库管理' then
          begin
            BringWindowToTop(frmCKProductBCPOutListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPOutListGL := TfrmCKProductBCPOutList.Create(application.MainForm);
          with frmCKProductBCPOutListGL do
          begin
            canshu1 := '管理';
            Title := '成品出库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPOutListGL.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPOutListGL.Handle;
      end;
    212:  //成品出库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品出库查询' then
          begin
            BringWindowToTop(frmCKProductBCPOutListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPOutListCX := TfrmCKProductBCPOutList.Create(application.MainForm);
          with frmCKProductBCPOutListCX do
          begin
            canshu1 := '查询';
            Title := '成品出库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPOutListCX.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPOutListCX.Handle;
      end;
    213:  //成品出库汇总
      begin
        if frmCKProductBCPOutListHZ = nil then
        begin
          frmCKProductBCPOutListHZ := TfrmCKProductBCPOutListHZ.Create(application.MainForm);
          with frmCKProductBCPOutListHZ do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPOutListHZ.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPOutListHZ.Handle;
      end;

    214:  //客户产品出库汇总（客户产品）
      begin
        if frmCPCKHZ = nil then
        begin
          frmCPCKHZ := TfrmCPCKHZ.Create(application.MainForm);
          with frmCPCKHZ do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPCKHZ.BringToFront;
       //句柄
        mnewHandle := frmCPCKHZ.Handle;
      end;
    311:  //库存列表
      begin
        if frmCKProductBCPKCList = nil then
        begin
          frmCKProductBCPKCList := TfrmCKProductBCPKCList.Create(application.MainForm);
          with frmCKProductBCPKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPKCList.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPKCList.Handle;
      end;

    312:  //库存汇总列表
      begin
        if frmCKProductBCPKCHZList = nil then
        begin
          frmCKProductBCPKCHZList := TfrmCKProductBCPKCHZList.Create(application.MainForm);
          with frmCKProductBCPKCHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPKCHZList.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPKCHZList.Handle;
      end;
    313:  //异常库存汇总
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '异常库存管理' then
          begin
            BringWindowToTop(frmCKProductBCCBPKCHZList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCCBPKCHZList := TfrmCKProductBCCBPKCHZList.Create(application.MainForm);
          with frmCKProductBCCBPKCHZList do
          begin
            canshu1 := '管理';
            Title := '异常库存管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCCBPKCHZList.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCCBPKCHZList.Handle;
      end;
    314:  //异常库存处理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '异常库存处理' then
          begin
            BringWindowToTop(frmCKProductBCCBPKCHZListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCCBPKCHZListCX := TfrmCKProductBCCBPKCHZList.Create(application.MainForm);
          with frmCKProductBCCBPKCHZListCX do
          begin
            canshu1 := '处理';
            Title := '异常库存处理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCCBPKCHZListCX.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCCBPKCHZListCX.Handle;
      end;

  end;

  Result := mnewHandle;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_FinishedClothWarehouse) then
    DataLink_FinishedClothWarehouse := TDataLink_FinishedClothWarehouse.Create(Application);
  try
    with DataLink_FinishedClothWarehouse.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_FinishedClothWarehouse.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

